//---------------------------------------------------------------------------
//
//   Symmetrize
//
//          Copyright(C) 2013, Tark
//
//	Ώ̈ʒuɈړ
//	쐬DLL"Plugins\Select"tH_ɓKvB
//
//---------------------------------------------------------------------------

#define WIN32_LEAN_AND_MEAN
#include <windows.h>
#include "MQPlugin.h"
#include "CMQObject.h"

#include <math.h>
#include <vector>
#include <unordered_set>
#include <unordered_map>
using namespace std;

//HINSTANCE hInstance;

//---------------------------------------------------------------------------
//  DllMain
//---------------------------------------------------------------------------
BOOL APIENTRY DllMain( HANDLE hModule, 
                       DWORD  ul_reason_for_call, 
                       LPVOID lpReserved
					 )
{
	//_CAO{bNX̕\ɕKvȂ̂ŁACX^XۑĂ
//	hInstance = (HINSTANCE)hModule;

	//vOCƂĂ͓ɕKvȏ͂Ȃ̂ŁATRUEԂ
	return TRUE;
}

//---------------------------------------------------------------------------
//  MQGetPlugInID
//    vOCIDԂB
//    ̊֐͋NɌĂяoB
//---------------------------------------------------------------------------
MQPLUGIN_EXPORT void MQGetPlugInID(DWORD *Product, DWORD *ID)
{
	// v_Ng(Җ)IDAS64bit̒lƂĕԂ
	// l͑ƏdȂ悤ȃ_Ȃ̂ŗǂ
	*Product = 0xE3F7A830;
	*ID      = 0xBD9A1864;
}

//---------------------------------------------------------------------------
//  MQGetPlugInName
//    vOCԂB
//    ̊֐[vOCɂ]\ɌĂяoB
//---------------------------------------------------------------------------
MQPLUGIN_EXPORT const char *MQGetPlugInName(void)
{
	// vOC
	return "Symmetrize Ver.1.0 Copyright(C) 2013, Tark.";
}

//---------------------------------------------------------------------------
//  MQGetPlugInType
//    vOC̃^CvԂB
//    ̊֐͋NɌĂяoB
//---------------------------------------------------------------------------
MQPLUGIN_EXPORT int MQGetPlugInType(void)
{
	// I𕔕ό`pvOCł
	return MQPLUGIN_TYPE_SELECT;
}

//---------------------------------------------------------------------------
//  MQEnumString
//    |bvAbvj[ɕ\镶ԂB
//    ̊֐͋NɌĂяoB
//---------------------------------------------------------------------------
MQPLUGIN_EXPORT const char *MQEnumString(int index)
{
	switch(index){
	case 0: return "Symmetrize near Vertex";
	case 1: return "Symmetrize Vertexes by other object";
	}
	return nullptr;
}

class Symmetrize
{
public:
	Symmetrize(MQDocument doc) :
			doc_(doc),
			obj_(doc->GetObject(doc->GetCurrentObjectIndex())) {}
	BOOL main();
private:
	CMQDocument doc_;
	CMQObject obj_; // JgIuWFNg
	int SymmetrizeVertex();

	static const float Symmetrize::symmax_distance; // Ώ̈ʒuƂ݂Ȃő勗
	static const float delta; // y-zʏ㔻p
};

// staticIuWFNg
const float Symmetrize::symmax_distance = 10.0f;
const float Symmetrize::delta = 0.001f;

class SymmetrizeReferObj
{
public:
	SymmetrizeReferObj(MQDocument doc) :
			doc_(doc),
			obj_(doc->GetObject(doc->GetCurrentObjectIndex())) {}
	BOOL main();
private:
	CMQDocument doc_;
	CMQObject obj_; // JgIuWFNg
	CMQObject objref_; // QƃIuWFNg

	unordered_map<UINT, UINT> selectAsymmetricVertex(CMQObject &obj);
	BOOL getSelectedObjectList();

	static float delta;
};

/*
class SymmetrizeLink
{
public:
	SymmetrizeLink(MQDocument doc) :
			doc_(doc),
			obj_(doc->GetObject(doc->GetCurrentObjectIndex())),
			do_symmetrize_uv(false) {}
	BOOL main();
private:
	CMQDocument doc_;
	CMQObject obj_; // JgIuWFNg
	bool do_symmetrize_uv;

	bool searchSymmetricVertex(int vindex1, int vindex2, unordered_set<int> &checked);
	vector<int> getAdjacent(int vindex, bool hand);
};
*/

float SymmetrizeReferObj::delta = 0.0001f;

//---------------------------------------------------------------------------
//  MQModifySelect
//    j[IꂽƂɌĂяoB
//---------------------------------------------------------------------------
MQPLUGIN_EXPORT BOOL MQModifySelect(int index, MQDocument doc)
{
	switch(index){
	case 0:
		{
			Symmetrize s(doc);
			return s.main();
		}
	case 1:
		{
			SymmetrizeReferObj s(doc);
			return s.main();
		}
	}
	return FALSE;
}

/*
	C[`
*/
BOOL Symmetrize::main()
{
	doc_.clearSelect(MQDOC_CLEARSELECT_LINE | MQDOC_CLEARSELECT_FACE);
	int count = SymmetrizeVertex();
	return count > 0 ? TRUE: FALSE;
}

int Symmetrize::SymmetrizeVertex()
{
	int vcount = obj_.getVertexCount();
	int movecount = 0; // ړ_̐
	for(int i = 0; i < vcount; i++) {
		if(obj_.getVertexRefCount(i) == 0) {
			continue;
		}
		if(!doc_.isSelectVertex(obj_, i)) {
			continue;
		}
		MQPoint pi = obj_.getVertex(i);
		if(abs(pi.x) < delta) {
			// ΏۋEʏ
			doc_.deleteSelectVertex(obj_, i);
			continue;
		}
		pi.x = -pi.x;
		bool is_symmetric = false;
		float distance_min2 = symmax_distance * symmax_distance;
		int vindex_min = -1;
		for(int j = 0; j < vcount; j++) {
			if(obj_.getVertexRefCount(j) == 0) {
				continue;
			}
			if(i == j) {
				continue;
			}
			MQPoint pj = obj_.getVertex(j);
			if(pi == pj) {
				// ҂Ώ̒_ʒuɂ
				distance_min2 = 0.0f;
				vindex_min = j;
				break;
			}
			float distance2 = (pi - pj).norm();
			if(distance2 < distance_min2) {
				distance_min2 = distance2;
				vindex_min = j;
			}
		}
		if(vindex_min == -1) {
			// Ώ̒_̈ԋ߂̂Ȃ
			doc_.addSelectVertex(obj_, i);
		}
		else if(distance_min2 == 0.0f) {
			// ɂ҂Ώ̈ʒuɂ
			doc_.deleteSelectVertex(obj_, i);
		}
		else {
			// Ώ̒_ʒuֈړđI
			MQPoint newpoint(obj_.getVertex(vindex_min));
			newpoint.x = -newpoint.x;
			obj_.setVertex(i, newpoint);
			doc_.deleteSelectVertex(obj_, i);
			movecount++;
		}
	}
	return movecount;
}

BOOL SymmetrizeReferObj::main()
{
	// QƃIuWFNgI
	if(!getSelectedObjectList()) {
		return FALSE;
	}

	// QƃIuWFNgΏ̒_֌W擾
	unordered_map<UINT, UINT> symmap = selectAsymmetricVertex(objref_);
	
	int vcount = obj_.getVertexCount();
	// I𒸓_
	for(int i = 0; i < vcount; i++) {
		if(obj_.getVertexRefCount(i) == 0) {
			continue;
		}
		if(!doc_.isSelectVertex(obj_, i)) {
			continue;
		}
		// j[NID
		UINT uid = obj_.getVertexUniqueID(i);
		auto it = symmap.find(uid);
		if(it == symmap.end()) {
			// QƃIuWFNgɑΏ̒_Ȃ̂łȂ
			continue;
		}
		UINT usym = it->second;
		int vsym = obj_.getVertexIndexFromUniqueID(usym);
		MQPoint p1 = obj_.getVertex(i);
		MQPoint p2 = obj_.getVertex(vsym);
		p2.x = -p2.x;
		if(p1 != p2) {
			// _ʒuZbg
			obj_.setVertex(i, p2);
		}
		else {
			doc_.deleteSelectVertex(obj_, i);
		}
	}
	return TRUE;	
}

unordered_map<UINT, UINT> SymmetrizeReferObj::selectAsymmetricVertex(CMQObject &obj)
{
	int vcount = obj_.getVertexCount();

	unordered_map<UINT, UINT> symmetric; // Ώ̒_yAi[
	for(int i = 0; i < vcount; i++) {
		if(obj.getVertexRefCount(i) == 0) {
			continue;
		}
		UINT uid = obj.getVertexUniqueID(i);
		if(symmetric.find(uid) != symmetric.end()) {
			// Ɍς
			continue;
		}
		MQPoint pi = obj.getVertex(i);
		if(abs(pi.x) < delta) {
			// ΏۋEʏ
			symmetric.insert(make_pair(uid, uid));
			continue;
		}
		pi.x = -pi.x;
		bool is_symmetric = false;
		for(int j = 0; j < vcount; j++) {
			if(obj.getVertexRefCount(j) == 0) {
				continue;
			}
			if(i == j) {
				continue;
			}
			MQPoint pj = obj.getVertex(j);
			if((pi - pj).norm() < delta * delta) {
				// Ώے_
				is_symmetric = true;
				UINT uidi = obj.getVertexUniqueID(i);
				UINT uidj = obj.getVertexUniqueID(j);
				symmetric.insert(make_pair(uidj, uidi));
				symmetric.insert(make_pair(uidi, uidj));
				break;
			}
		}
	}
	return symmetric;
}

BOOL SymmetrizeReferObj::getSelectedObjectList()
{
	int selected_count = 0;
	for(int i = 0; i < doc_.getObjectCount(); i++) {
		CMQObject obj = doc_.getObject(i);
		if(!obj) {continue;}
		if(obj.getSelected()) {
			if(selected_count == 0) {obj_ = obj;}
			else if(selected_count == 1) {objref_ = obj;}
			else {break;}
			selected_count++;
		}
	}
	if(selected_count < 2) {
		return FALSE;
	}
	return TRUE;
}

/*
	_̐ڑǐՂđΏ̍\͂āAΏ̉
	c肾ǖ

int SymmetrizeLink::main()
{
	// N__
	int vstart = -1;
	int vstartsym = -1; // __̑Ώ̒_
	for(int i = 0; i < obj_.getVertexCount(); i++) {
		if(obj_.getVertexRefCount(i) != 0 && doc_.isSelectVertex(obj_, i)) {
			// I𒸓_
			vstart = i;
			MQPoint pstart = obj_.getVertex(vstart);
			// N_Ώ̓_
			for(int j = 0; j < obj_.getVertexCount(); j++) {
				if(i == j) {
					continue;
				}
				if(obj_.getVertexRefCount(j) != 0) {
					MQPoint psym = obj_.getVertex(j);
					psym.x = -psym.x;
					if(pstart == psym) {
						vstartsym = j;
						break;
					}
				}
			}
			if(vstartsym != -1) {
				break;
			}
		}
	}
	if(vstart == -1 || vstartsym == -1) {
		return FALSE;
	}
	unordered_set<int> checked;
	bool ret = searchSymmetricVertex(vstart, vstartsym, checked);
}

bool SymmetrizeLink::searchSymmetricVertex(int vindex1, int vindex2, unordered_set<int> &checked)
{
	MQPoint p1 = obj_.getVertex(vindex1);
	MQPoint p2 = obj_.getVertex(vindex2);
	p2.x = -p2.x;
	if(p1 != p2) {
		// Ώ̒_ƍWقȂĂ獇킹
		obj_.setVertex(vindex1, p2);
	}
	checked.insert(vindex1);
	if(do_symmetrize_uv) {
		// UVl킹
		auto faces1 = obj_.getVertexRelatedFaces(vindex1);
		auto faces2 = obj_.getVertexRelatedFaces(vindex2);
		if(faces1.size() != faces2.size()) {
			// Ώ̍\ł͂Ȃ
			return false;
		}
		for(int i = 0; i < faces1.size(); i++) {
			auto varray = obj_.getFacePointArray(faces1[i]);
			for(int j = 0; j < varray.size(); j++) {
				if(varray[j] == vindex1) {
					auto coordarray = obj_.getFaceCoordinateArray(faces2[faces2.size() - i - 1]);
					if(coordarray.size() != varray.size()) {
						// Ώ̍\ł͂Ȃ
						return false;
					}
					CMQCoordinate co = coordarray[coordarray.size() - j - 1];
					obj_.setFaceCoordinateArray(faces1[i], j, co);
					break;
				}
			}
		}
	}
	vector<int> adjacent1 = getAdjacent(vindex1, true);
	vector<int> adjacent2 = getAdjacent(vindex2, false);
	int adjsize = adjacent1.size();
	if(adjsize != adjacent2.size()) {
		// _\vȂ
		return false;
	}
	// 킹
	//rotate_copy(adjacent2,...);

	for(int i = 0; i < adjsize; i++) {
		int adj1 = adjacent1[i];
		if(!doc_.isSelectVertex(obj_, adj1)) {
			// I͈͊O
			continue;
		}
		if(checked.find(adj1) != checked.end()) {
			// Tς
			continue;
		}
		MQPoint pa = obj_.getVertex(adj1);
		if(pa.x * p1.x <= 0.0f) {
			// y-zʂ𒴂Ȃ悤ɂ
			continue;
		}
		int adj2 = adjacent2[adjsize - i - 1];
		bool ret = searchSymmetricVertex(adj1, adj2, checked);
		if(!ret) {
			return ret;
		}
	}
	return true;
}

vector<int> SymmetrizeLink::getAdjacent(int vindex, bool hand)
{
	vector<int> adjacent;
	vector<int> faces = obj_.getVertexRelatedFaces(vindex);
	int fromi = hand ? 0 : faces.size() - 1;
	int toi = hand ? faces.size() : -1;
	int adderi = hand ? 1 : -1;
	for(int i= fromi; i != toi; i += adderi) {
		vector<int> vertexes = obj_.getFacePointArray(faces[i]);
		int vcount = vertexes.size();
		if(vcount == 2) {
			int v = vertexes[0] == vindex ? vertexes[1] : vertexes[0];
			if(find(adjacent.begin(), adjacent.end(), v) == adjacent.end()) {
				adjacent.push_back(v);
			}
		}
		else {
			int fromj = hand ? 0 : vcount - 1;
			int toj = hand ? vcount : -1;
			int adderj = hand ? 1 : -1;
			for(int j = fromj; j != toj; j += adderj) {
				if(vertexes[j] == vindex) {
					int v = vertexes[(j + vcount + adderj) % vcount];
					if(find(adjacent.begin(), adjacent.end(), v) == adjacent.end()) {
						adjacent.push_back(v);
					}
					v = vertexes[(j + vcount - adderj) % vcount];
					if(find(adjacent.begin(), adjacent.end(), v) == adjacent.end()) {
						adjacent.push_back(v);
					}
					break;
				}
			}
		}
	}
	return adjacent;
}
*/
